com.io7m.jstructural.annotated

## Class SAParagraphNumber

- java.lang.Object
- - com.io7m.jstructural.annotated.SAParagraphNumber

- All Implemented Interfaces:
    SASubsectionContentNumber, Comparable<SAParagraphNumber>
  Direct Known Subclasses:
    SAParagraphNumberPSP, SAParagraphNumberPSSP, SAParagraphNumberSP, SAParagraphNumberSSP

      public abstract class SAParagraphNumber
      extends Object
      implements Comparable<SAParagraphNumber>, SASubsectionContentNumber

  An abstract paragraph number.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SAParagraphNumber()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract int` | `getParagraph()`
    `abstract <T> T` | `paragraphNumberAccept(SAParagraphNumberVisitor<T> v)` Accept a paragraph number visitor.
    `abstract String` | `paragraphNumberFormat()`
    `<T> T` | `subsectionContentNumberAccept(SASubsectionContentNumberVisitor<T> v)` Accept a subsection content number visitor.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Constructor Detail

    - #### SAParagraphNumber

          public SAParagraphNumber()

  - ### Method Detail

    - #### getParagraph

          public abstract int getParagraph()

      Returns:
        The paragraph number

    - #### paragraphNumberAccept

          public abstract <T> T paragraphNumberAccept(@Nonnull
                                    SAParagraphNumberVisitor<T> v)
                                           throws com.io7m.jaux.Constraints.ConstraintError,
                                                  Exception

      Accept a paragraph number visitor.
      Type Parameters:
        `T` - The type of values returned by the visitor
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises `Constraints.ConstraintError`
        `Exception` - If the visitor raises an `Exception`

    - #### paragraphNumberFormat

          public abstract String paragraphNumberFormat()

      Returns:
        A human-readable string representing the paragraph number (such as "1.2.3.4")

    - #### subsectionContentNumberAccept

          public final <T> T subsectionContentNumberAccept(@Nonnull
                                            SASubsectionContentNumberVisitor<T> v)
                                                throws com.io7m.jaux.Constraints.ConstraintError,
                                                       Exception

      Description copied from interface: `SASubsectionContentNumber`
      Accept a subsection content number visitor.
      Specified by:
        `subsectionContentNumberAccept` in interface `SASubsectionContentNumber`
      Type Parameters:
        `T` - The type of values returned by the visitor
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `com.io7m.jaux.Constraints.ConstraintError` - If the visitor raises `Constraints.ConstraintError`
        `Exception` - If the visitor raises an `Exception`

Copyright © 2014 <code@io7m.com> http://io7m.com